\documentclass[10pt,twoside]{article}
\usepackage[left=1cm,right=1cm,top=2cm,bottom=2cm]{geometry} \usepackage{xspace} \usepackage{longtable}
\newcommand{\mkl}{\textsc{MKL}\xspace}
    \newcommand{\lapack}{\textsc{LAPACK}\xspace}
    \newcommand{\blas}{\textsc{BLAS}\xspace}
    \newcommand{\scalapack}{\textsc{ScaLAPACK}\xspace}
    \newcommand{\mumps}{\textsc{MUMPS}\xspace}
    \newcommand{\hwloc}{\textsc{HWLOC}\xspace}
    \newcommand{\scotch}{\textsc{SCOTCH}\xspace}
    \newcommand{\pastix}{\textsc{PaStiX }\xspace}
    \newcommand{\fabulous}{\textsc{FABuLOuS}\xspace}
    \newcommand{\maphys}{\textsc{MaPHyS}\xspace}
    \newcommand{\mpi}{\textsc{MPI}\xspace} 
\begin{document}
\section*{\maphys version 1.0.0 }
\subsection*{ICNTL}
\begin{longtable}[H]{| p{.1\textwidth} | p{.7\textwidth} | p{.1\textwidth} |} \hline  
Parameter & Description and values & Default value\\ \hline 
ICNTL(1) & Error ouput for MaPHyS. & 0 (stderr)\\
\hline
ICNTL(2) & Output for MaPHyS warnings. & 0 (stderr)\\
\hline
ICNTL(3) & Standard output for MaPHyS. & 6 (stdout)\\
\hline
ICNTL(4) & Output verbosity. & 3\\
 & 1: Print errors. & \\
 & 2: Print errors, warnings and main statistics. & \\
 & 3: Print errors, warnings and detailled statistics. & \\
 & 4: Print errors, warnings and more detailled statistics. & \\
\hline
ICNTL(5) & When to print control options. & 0\\
 & 0: Never print. & \\
 & 1: Print once at the begining of analysis. & \\
 & 2: Print at the begining of each step. & \\
\hline
ICNTL(6) & When to print info arrays. & 0\\
 & 0: Never print. & \\
 & 1: Print once at the begining of analysis. & \\
 & 2: Print at the begining of each step. & \\
\hline
ICNTL(8) & Level of filling for L and U when using PILUT solver. & -1\\
\hline
ICNTL(9) & Level of filling for the Schur when using PILUT solver. & -1\\
\hline
ICNTL(13) & The sparse direct solver package to be used. & 1\\
 & 1: Use \mumps. & \\
 & 2: Use \pastix. & \\
 & 3: Use multiple sparse direct solvers. See ICNTL(15) and ICNTL(32). & \\
\hline
ICNTL(14) & Output format. & 0\\
 & 0: Standard output. & \\
 & 1: Emacs orgmode output. & \\
\hline
ICNTL(15) & Sparse direct solver to compute the preconditioner. & ICNTL(13)\\
 & 1: Use \mumps. & \\
 & 2: Use \pastix. & \\
\hline
ICNTL(20) & Controls the 3rd party iterative solver to be used. & 3\\
 & 0: Unset. & \\
 & 1: Use Pack GMRes. & \\
 & 2: Use Pack CG. & \\
 & 3: automatic selection. & \\
 & 4: Use Fabulous. & \\
\hline
ICNTL(21) & Set the preconditioner to be used. & 2\\
 & 1: Dense factorization of the schur. & \\
 & 2: Sparse factorization of the schur. See RCNTL(11) for the dropping threshold. & \\
 & 3: Sparse factorization using PILUT. See RCNTL(9) for the dropping threshold. & \\
 & 4: No preconditioner. & \\
 & 5: Autodetect. & \\
 & 10: Dense factorization of the schur with CGC. & \\
\hline
ICNTL(22) & Determines which orthogonalisation scheme to apply. & 3\\
 & 0: Modified Gram-Schmidt orthogonalization (MGS). & \\
 & 1: Iterative selective modified Gram-Schmidt orthogonalization (IMGS). & \\
 & 2: Classical Gram-Schmidt orthogonalization (CGS) & \\
 & 3: Iterative classical Gram-Schmidt orthogonalisation (ICGS) & \\
\hline
ICNTL(23) & Supply an initial guess. & 0\\
 & 0: No initial guess (start with null vector). & \\
 & 1: User defined initial guess. & \\
\hline
ICNTL(24) & Maximum number of iterations (cumulated). & 100\\
\hline
ICNTL(25) & Strategy to compute the residual at the restart (GMRes). & 0\\
 & 0: Use a recurrence formula. & \\
 & 1: The residual is explicitly computed. & \\
\hline
ICNTL(26) & Restart parameter for GMRes or \fabulous. & 100\\
\hline
ICNTL(27) & Method to perform multiplication between the Schur and a vector. & 0\\
 & 0: Automatic (1 if possible, 2 if not). & \\
 & 1: Explicit matrix vector product. & \\
 & 2: Implicit matrix vector product. & \\
\hline
ICNTL(28) & Controls how to compute scaled residual. & 1\\
 & 0: Compute the normalized residual with $\frac{|| A.x - b ||_2}{ ||b_{\Gamma}||_2}$. & \\
 & 1: Compute the normalized residual with $\frac{|| A.x - b ||_2}{ ||b||_2}$. & \\
 & 2: Use $\frac{|| A.x - b ||_2}{\alpha ||x||_2 + \beta}$, $\alpha$ = RCNTL(3), $\beta$ = RCNTL(4). Not available with \fabulous. & \\
\hline
ICNTL(29) & Mode of the iterative solver \fabulous (see ICNTL(20)). & 1\\
 & 0: Use standard Block GMRes algorithm. & \\
 & 1: Use Block GMRes algorithm with detection of Inexact Breakdowns. & \\
 & 2: Use Block GMRes algorithm with incremental QR. & \\
 & 3: Use Block GMRes algorithm with Deflated Restart. See ICNTL(48) and RCNTL(2). & \\
 & 4: Use BGMRES with Inexact Breakdowns and Deflated Restart. See ICNTL(48) and RCNTL(2) to control this option. & \\
 & 5: Use BGMRES with Incremental QR and Inexact Breakdowns. & \\
 & 6: Use BGMRES with Incremental QR and deflated restarting. See ICNTL(48) and RCNTL(2) to control this option. & \\
 & 7: Use BGMRES with Incremental QR, Inexact Breakdowns and deflated restarting. See ICNTL(48) and RCNTL(2) to control this option. & \\
 & 8: Use BGCR (Block General Conjugate Residual). & \\
\hline
ICNTL(30) & How to compute the schur complement matrix or its approximation. & 0\\
 & 0: Use the schur complement returned by the sparse direct solver package. & \\
 & 2: Use PILUT (set ICNTL(8), ICNTL(9), RCNTL(8) and RCNTL(9)). & \\
\hline
ICNTL(32) & Sparse direct solver to compute local Schur and local factorization. & ICNTL(13)\\
 & 1: Use \mumps. & \\
 & 2: Use \pastix. & \\
\hline
ICNTL(33) & Number of eigenvalues per subdomain to keep for the CGC (ICNTL(21)=10). & 10\\
\hline
ICNTL(34) & Keep convergence history in output file. & 0\\
 & 0: Convergence history is treated as regular output. & \\
 & 1: Convergence history is written in a file. & \\
\hline
ICNTL(36) & Thread binding. & 2\\
 & 0: Do not bind. & \\
 & 1: Thead to core bind. & \\
 & 2: Grouped bind. & \\
\hline
ICNTL(37) & Number of nodes. Only useful if ICNTL(42) $>$ 0. & 0\\
\hline
ICNTL(38) & Number of core per node. Only useful if ICNTL(42) $>$ 0. & 1\\
\hline
ICNTL(39) & Number of thread per domain. Only useful if ICNTL(42) $>$ 0. & 1\\
\hline
ICNTL(40) & Number of domains. Only useful if ICNTL(42) $>$ 0. & 1\\
\hline
ICNTL(42) & Activate second level of parallelism. ICNTLS 36 to 40 must be set. & 0\\
 & 0: Only MPI will be used. & \\
 & 1: Activate the multithreading on top of MPI. & \\
\hline
ICNTL(43) & Specifies the input system (centralized on the host, distributed, ...). & 1\\
 & 1: Centralized on the host. & \\
 & 2: The input system is distributed. & \\
\hline
ICNTL(44) & When activated, user must describe permutation to be used. & 0\\
 & 0: Distribution is performed by \maphys. & \\
 & 1: Distribution is provided by the user as describe before. & \\
\hline
ICNTL(45) & Set to 1 to dump local matrices, rhs and domain data after analysis. & 0\\
 & 0: No analysis dump. & \\
 & 1: Dump matrices, rhs and domain data in files after analysis. & \\
\hline
ICNTL(47) & \mumps percentage increase in the estimated working space. & 20\\
\hline
ICNTL(48) & Number of eigen vectors to keep for the next restart (\fabulous DR). & 10\\
\hline
ICNTL(49) & controls the choice of the domain decomposition library/algorithm. & 1\\
 & 1: \maphys internal algorithm & \\
 & 2: Paddle external library & \\
\hline
ICNTL(50) & What to do when \mumps requires more working space. & 0\\
 & 0: The \mumps error is considered fatal. & \\
 & $>0$: Each time the error occurs, this value is added to the extra workspace ICNTL(47). & \\
 & -1: Each time the error occurs, the extra workspace ICNTL(47) is multiplied by RCNTL(5). & \\
\hline
ICNTL(51) & Strategy to apply the 2-level coarse preconditioner & 2\\
 & 0: Use \mumps, distributed mode & \\
 & 1: Use \lapack, sequential only & \\
 & 2: Use ICNTL(13) sparse direct solver with ICNTL(52) processes & \\
 & 3: Duplicate coarse problem on groups of MPI processes with ICNTL(52) processes per group & \\
 & 4: Make groups of ICNTL(52) processes to centralize, and compute with distributed SDS on the masters. & \\
\hline
ICNTL(52) & Number of MPI processes to compute and apply the 2-level coarse preconditioner & 1\\
\hline
ICNTL(55) & Orthogonalization is either vector-by-vector (RUHE) or block-by-block (BLOCK) & 0\\
 & 0: Orthogonalize vector one-by-one (RUHE variant) & \\
 & 1: Orthogonalize vector block-by-block & \\
\hline
ICNTL(56) & When using CG, choose stopping criterion. & 1\\
 & 1: Use normwise backward error based on scaled residual. & \\
 & 2: Use lower bound of the A-norm of the error. & \\
\hline
ICNTL(57) & If ICNTL(56) = 2, number of additionnal iterations to be performed. & 5\\
\hline
ICNTL(60) & Keep preconditioner when multiple driver calls with job = 6. & 0\\
 & 0: Do not keep the preconditioner & \\
 & 1: Keep the preconditioner, recompute it every ICNTL(61) calls to the driver with job = 6. & \\
\hline
ICNTL(61) & Frequency to recompute the preconditioner when ICNTL(60) = 1 & 0\\
 & 0: Never recompute the preconditioner & \\
 & N $>0$: Recompute the preconditioner each N iteration(s) & \\
\hline
ICNTL(62) & Control MUMPS's ICNTL of 7: the ordering tool (scotch/metis/pord...) & 5\\
\hline
\end{longtable}
\subsection*{RCNTL}
\begin{longtable}[H]{| p{.1\textwidth} | p{.7\textwidth} | p{.1\textwidth} |} \hline  
Parameter & Description and values & Default value\\ \hline 
RCNTL(2) & Eigen vectors target for \fabulous DR algo. & 0.0\\
\hline
RCNTL(3) & Set $\alpha $ for the stopping criterion, when ICNTL(28) = 2. & 0\\
\hline
RCNTL(4) & Set $\beta$ for the stopping criterion, when ICNTL(28) = 2. & 0\\
\hline
RCNTL(5) & Multiply the extra workspace for \mumps by this value when \mumps error occurs. & 2.0\\
\hline
RCNTL(8) & Threshold used to sparsify the LU factors while using PILUT. & 0.0\\
\hline
RCNTL(9) & Threshold used to sparsify the schur complement while computing it with PILUT. & 0.0\\
\hline
RCNTL(11) & The threshold used to sparsify the Schur complement while computing a sparse preconditioner. & 1e-4\\
\hline
RCNTL(15) & Imbalance tolerance used in Scotch partitionner to create the subdomains. & 0.2\\
\hline
RCNTL(21) & Threshold for the stopping criterion within the iterative solve step. & 1e-05\\
\hline
\end{longtable}
\subsection*{IINFO}
\begin{longtable}[H]{| p{.15\textwidth} | p{.75\textwidth} | } \hline  
 Output & Description and values \\ \hline 
IINFO(1) & The status of the instance.\\
 & 0: Success. \\
 & $<0$: Failure. \\
 & $>0$: Warning. \\
\hline
IINFO(3) & Flag for the strategy used to partition the input linear system.\\
\hline
IINFO(4) & Local matrix order.\\
\hline
IINFO(5) & Size in MegaBytes used to store the local matrice and its sub-blocks.\\
\hline
IINFO(6) & Number of entries in the local matrix order.\\
\hline
IINFO(7) & Flag indicating which sparse direct solver was used for the factorization.\\
\hline
IINFO(8) & Flag indicating how the Schur was computed.\\
\hline
IINFO(9) & Size in MegaBytes used to stores the factors of the local matrix.\\
\hline
IINFO(10) & The number of static pivots during the factorization.\\
\hline
IINFO(11) & Number of static pivots during the factorization.\\
\hline
IINFO(12) & Size in MegaBytes used to stores the Schur complement.\\
\hline
IINFO(13) & Number of entries in the approximation of the local Schur. Only with ILU.\\
\hline
IINFO(14) & Preconditioner strategy.\\
\hline
IINFO(15) & Which sparse direct solver was used to compute the preconditioner.\\
\hline
IINFO(16) & The order of the preconditioner.\\
\hline
IINFO(17) & Size in MegaBytes used to stores the preconditioner.\\
\hline
IINFO(18) & The number of static pivots done while computing the preconditioner.\\
\hline
IINFO(19) & Percentage of kept entries in the assembled Schur to build the local part of the preconditionner.\\
\hline
IINFO(20) & Iterative solver used for the solve.\\
\hline
IINFO(21) & Specifies the Schur matrix vector product.\\
\hline
IINFO(22) & Size in MegaBytes of local data allocated for the sparse direct solver.\\
\hline
IINFO(23) & Size in MegaBytes of local data allocated to compute the preconditioner.\\
\hline
IINFO(24) & MaPHys memory peak estimation, in MegaBytes.\\
\hline
IINFO(25) & MaPHys memory current cost estimation, in MegaBytes.\\
\hline
IINFO(26) & Upper bound for memory usage of the iterative solver.\\
\hline
IINFO(27) & Upper bound for memory peak of the iterative solver.\\
\hline
IINFO(28) & Memory currently used in \maphys buffers.\\
\hline
IINFO(29) & Memory peak in \maphys buffers.\\
\hline
IINFO(30) & The internal memory usage of the sparse direct solver library.\\
\hline
IINFO(31) & The internal memory peak of the sparse direct solver library.\\
\hline
IINFO(32) & The identifier of the node (from 1 to the number of nodes).\\
\hline
IINFO(33) & The number of domains associated to the node.\\
\hline
IINFO(34) & The amount of memory used on the node in MegaBytes.\\
\hline
IINFO(35) & The amount of memory peak on the node in MegaBytes.\\
\hline
IINFO(36) & The number of non zero in the schur after the factorisation.\\
\hline
IINFO(37) & Effective memory usage of the iterative solver.\\
\hline
\end{longtable}
\subsection*{RINFO}
\begin{longtable}[H]{| p{.15\textwidth} | p{.75\textwidth} | } \hline  
 Output & Description and values \\ \hline 
RINFO(2) & Norm 1 of the Schur stored in dense matrix, when ICNTL(21) = 1.\\
\hline
RINFO(3) & Reciproque of the condition number of the Schur.\\
\hline
RINFO(4) & Execution Time of the analysis step.\\
\hline
RINFO(5) & Execution Time of the factorisation step.\\
\hline
RINFO(6) & Execution Time of the precond step.\\
\hline
RINFO(7) & Execution Time of the solution step.\\
\hline
RINFO(8) & Time to preprocess the input matrix.\\
\hline
RINFO(9) & Time to convert the input system into local system.\\
\hline
RINFO(10) & Time to extract subblocks of the local matrix.\\
\hline
RINFO(11) & Time to factorize the local matrix.\\
\hline
RINFO(12) & Time to compute the Schur complement or its approximation.\\
\hline
RINFO(13) & Time to assemble the Schur complement or its approximation.\\
\hline
RINFO(14) & Time to factorize the assembled Schur complement (the preconditioner).\\
\hline
RINFO(15) & The solve step, execution time to distribute the global right-hand side.\\
\hline
RINFO(16) & In the solve step, execution time to generate right-hand side of the iterative solver.\\
\hline
RINFO(17) & In the solution step, execution time of the iterative solver (to solve the interface).\\
\hline
RINFO(18) & In the solution step, execution time of the sparse direct solver (to solve the interiors).\\
\hline
RINFO(19) & In the solution step, execution time to gather the solution.\\
\hline
RINFO(20) & Sum of the execution times of the 4 steps. It is available after the solution step.\\
\hline
RINFO(21) & Total execution time from the begining of the analysis to the end of the solve.\\
\hline
RINFO(22) & Floating operations for the elimination process on the local system.\\
\hline
RINFO(23) & Floating operations for the assembly process on the local system.\\
\hline
RINFO(24) & Floating operations for the elimination process on the local system.\\
\hline
RINFO(25) & Floating operations for the elimination process to obtain the sparse preconditioner.\\
\hline
RINFO(26) & Floating point operations for the assembly process to obtain the sparse preconditioner.\\
\hline
RINFO(27) & Floating point operations for the elimination to get the sparse preconditioner factorisation.\\
\hline
RINFO(28) & The time spent to perform communications while calling the iterative solver.\\
\hline
RINFO(29) & Total time spent to perform the matrix-vector products in the iterative solver.\\
\hline
RINFO(30) & Total time spent to apply the preconditioner in the iterative solver.\\
\hline
RINFO(31) & Total time spent to perform scalar products in the iterative solver.\\
\hline
RINFO(32) & Total time spent to apply local dense preconditioner with CGC\\
\hline
RINFO(33) & Total time spent to apply global preconditioner with CGC\\
\hline
RINFO(34) & Total time spent to apply global preconditioner with CGC, solve call\\
\hline
RINFO(35) & Total time spent to apply global preconditioner with CGC, communications\\
\hline
RINFO(36) & Total time spent to assemble the global rhs with CGC\\
\hline
RINFO(37) & Total time spent to solve generalized eigen problem for CGC preconditionner.\\
\hline
RINFO(38) & Total time spent to compute local coarse grid for CGC preconditionner.\\
\hline
RINFO(39) & Total time spent to compute global preconditionner for CGC preconditionner.\\
\hline
\end{longtable}
\subsection*{IINFOG}
\begin{longtable}[H]{| p{.15\textwidth} | p{.75\textwidth} | } \hline  
 Output & Description and values \\ \hline 
IINFOG(1) & The instance status.\\
 & $<0$: Error state. \\
 & 0: Instance is in a correct state. \\
 & -1: An error occured on process IINFOG(2). \\
\hline
IINFOG(2) & If INFOG(1) = 1, specifies which process failed (from 1 to the number of processes.).\\
\hline
IINFOG(3) & Order of the input matrix.\\
\hline
IINFOG(4) & Number of entries in the input matrix. It is only available on process 0.\\
\hline
IINFOG(5) & Number of iterations performed by the iterative solver.\\
\hline
IINFOG(6) & Number of matrix block products performed by \fabulous.\\
\hline
\end{longtable}
\subsection*{RINFOG}
\begin{longtable}[H]{| p{.15\textwidth} | p{.75\textwidth} | } \hline  
 Output & Description and values \\ \hline 
RINFOG(2) & Value of $\frac{|| A.x - b ||_2}{ ||b||_2}$ estimated in centralized form\\
\hline
RINFOG(3) & The backward error of the Schur system.\\
\hline
RINFOG(4) & Value of $\frac{|| A.x - b ||_2}{ ||b||_2}$ estimated in distributed form.\\
\hline
\end{longtable}
\end{document}